Index: group__wireless.html
===================================================================
--- group__wireless.html	(revision 78)
+++ group__wireless.html	(revision 79)
@@ -48,6 +48,18 @@
 <tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g0a1a0e4d885f0e0dde87160a16daa0aa">wl_send_pan_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots in our PAN.  <a href="#g0a1a0e4d885f0e0dde87160a16daa0aa"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g211ccf907dce4493813573e20264e542">wl_set_pan</a> (int pan)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the PAN we are using.  <a href="#g211ccf907dce4493813573e20264e542"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g4e6b5c97d40a8e7557a1b4b90a7d34f7">wl_get_pan</a> (void)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the PAN we are using.  <a href="#g4e6b5c97d40a8e7557a1b4b90a7d34f7"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g9aac809e57c9eb93a2905ed544c93aba">wl_set_channel</a> (int channel)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the channel we are using.  <a href="#g9aac809e57c9eb93a2905ed544c93aba"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g2d65d3e35b193da4213755c4bf61ab6b">wl_get_channel</a> (void)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the channel we are using.  <a href="#g2d65d3e35b193da4213755c4bf61ab6b"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g90cb41c855ac3da028e8f1278bd49f4f">wl_get_xbee_id</a> (void)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the 16-bit address of the XBee module.  <a href="#g90cb41c855ac3da028e8f1278bd49f4f"></a><br></td></tr>
@@ -92,6 +104,72 @@
 Performs wireless library functionality. This function must be called frequently for wireless to perform effectively. This function will call timeout handlers, as well as received packet and transmit status handlers.     </td>
   </tr>
 </table>
+<a class="anchor" name="g2d65d3e35b193da4213755c4bf61ab6b"></a><!-- doxytag: member="wireless.h::wl_get_channel" ref="g2d65d3e35b193da4213755c4bf61ab6b" args="(void)" --><p>
+<table class="mdTable" cellpadding="2" cellspacing="0">
+  <tr>
+    <td class="mdRow">
+      <table cellpadding="0" cellspacing="0" border="0">
+        <tr>
+          <td class="md" nowrap valign="top">int wl_get_channel           </td>
+          <td class="md" valign="top">(&nbsp;</td>
+          <td class="md" nowrap valign="top">void&nbsp;</td>
+          <td class="mdname1" valign="top" nowrap>          </td>
+          <td class="md" valign="top">&nbsp;)&nbsp;</td>
+          <td class="md" nowrap></td>
+        </tr>
+      </table>
+    </td>
+  </tr>
+</table>
+<table cellspacing="5" cellpadding="0" border="0">
+  <tr>
+    <td>
+      &nbsp;
+    </td>
+    <td>
+
+<p>
+Get the channel we are using. 
+<p>
+Get the channel the XBee is part of.<p>
+<dl compact><dt><b>Returns:</b></dt><dd>the channel the XBee is part of</dd></dl>
+<dl compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g9aac809e57c9eb93a2905ed544c93aba">wl_set_channel</a> </dd></dl>
+    </td>
+  </tr>
+</table>
+<a class="anchor" name="g4e6b5c97d40a8e7557a1b4b90a7d34f7"></a><!-- doxytag: member="wireless.h::wl_get_pan" ref="g4e6b5c97d40a8e7557a1b4b90a7d34f7" args="(void)" --><p>
+<table class="mdTable" cellpadding="2" cellspacing="0">
+  <tr>
+    <td class="mdRow">
+      <table cellpadding="0" cellspacing="0" border="0">
+        <tr>
+          <td class="md" nowrap valign="top">int wl_get_pan           </td>
+          <td class="md" valign="top">(&nbsp;</td>
+          <td class="md" nowrap valign="top">void&nbsp;</td>
+          <td class="mdname1" valign="top" nowrap>          </td>
+          <td class="md" valign="top">&nbsp;)&nbsp;</td>
+          <td class="md" nowrap></td>
+        </tr>
+      </table>
+    </td>
+  </tr>
+</table>
+<table cellspacing="5" cellpadding="0" border="0">
+  <tr>
+    <td>
+      &nbsp;
+    </td>
+    <td>
+
+<p>
+Get the PAN we are using. 
+<p>
+Get the PAN the XBee is currently part of.<p>
+<dl compact><dt><b>Returns:</b></dt><dd>the PAN of the XBee</dd></dl>
+<dl compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g211ccf907dce4493813573e20264e542">wl_set_pan</a> </dd></dl>
+    </td>
+  </tr>
+</table>
 <a class="anchor" name="g90cb41c855ac3da028e8f1278bd49f4f"></a><!-- doxytag: member="wireless.h::wl_get_xbee_id" ref="g90cb41c855ac3da028e8f1278bd49f4f" args="(void)" --><p>
 <table class="mdTable" cellpadding="2" cellspacing="0">
   <tr>
@@ -472,6 +550,80 @@
     </td>
   </tr>
 </table>
+<a class="anchor" name="g9aac809e57c9eb93a2905ed544c93aba"></a><!-- doxytag: member="wireless.h::wl_set_channel" ref="g9aac809e57c9eb93a2905ed544c93aba" args="(int channel)" --><p>
+<table class="mdTable" cellpadding="2" cellspacing="0">
+  <tr>
+    <td class="mdRow">
+      <table cellpadding="0" cellspacing="0" border="0">
+        <tr>
+          <td class="md" nowrap valign="top">void wl_set_channel           </td>
+          <td class="md" valign="top">(&nbsp;</td>
+          <td class="md" nowrap valign="top">int&nbsp;</td>
+          <td class="mdname1" valign="top" nowrap> <em>channel</em>          </td>
+          <td class="md" valign="top">&nbsp;)&nbsp;</td>
+          <td class="md" nowrap></td>
+        </tr>
+      </table>
+    </td>
+  </tr>
+</table>
+<table cellspacing="5" cellpadding="0" border="0">
+  <tr>
+    <td>
+      &nbsp;
+    </td>
+    <td>
+
+<p>
+Set the channel we are using. 
+<p>
+Set the channel the XBee is listening to.<p>
+<dl compact><dt><b>Parameters:</b></dt><dd>
+  <table border="0" cellspacing="2" cellpadding="0">
+    <tr><td valign="top"></td><td valign="top"><em>channel</em>&nbsp;</td><td>the new channel to join</td></tr>
+  </table>
+</dl>
+<dl compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g2d65d3e35b193da4213755c4bf61ab6b">wl_get_channel</a> </dd></dl>
+    </td>
+  </tr>
+</table>
+<a class="anchor" name="g211ccf907dce4493813573e20264e542"></a><!-- doxytag: member="wireless.h::wl_set_pan" ref="g211ccf907dce4493813573e20264e542" args="(int pan)" --><p>
+<table class="mdTable" cellpadding="2" cellspacing="0">
+  <tr>
+    <td class="mdRow">
+      <table cellpadding="0" cellspacing="0" border="0">
+        <tr>
+          <td class="md" nowrap valign="top">void wl_set_pan           </td>
+          <td class="md" valign="top">(&nbsp;</td>
+          <td class="md" nowrap valign="top">int&nbsp;</td>
+          <td class="mdname1" valign="top" nowrap> <em>pan</em>          </td>
+          <td class="md" valign="top">&nbsp;)&nbsp;</td>
+          <td class="md" nowrap></td>
+        </tr>
+      </table>
+    </td>
+  </tr>
+</table>
+<table cellspacing="5" cellpadding="0" border="0">
+  <tr>
+    <td>
+      &nbsp;
+    </td>
+    <td>
+
+<p>
+Set the PAN we are using. 
+<p>
+Set the PAN for the XBee to join.<p>
+<dl compact><dt><b>Parameters:</b></dt><dd>
+  <table border="0" cellspacing="2" cellpadding="0">
+    <tr><td valign="top"></td><td valign="top"><em>pan</em>&nbsp;</td><td>the new PAN</td></tr>
+  </table>
+</dl>
+<dl compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g4e6b5c97d40a8e7557a1b4b90a7d34f7">wl_get_pan</a> </dd></dl>
+    </td>
+  </tr>
+</table>
 <a class="anchor" name="g66075ff87a1c9f2c0d7938a26c7830f2"></a><!-- doxytag: member="wireless.h::wl_terminate" ref="g66075ff87a1c9f2c0d7938a26c7830f2" args="(void)" --><p>
 <table class="mdTable" cellpadding="2" cellspacing="0">
   <tr>
@@ -538,7 +690,7 @@
     </td>
   </tr>
 </table>
-<hr size="1"><address style="align: right;"><small>Generated on Mon Sep 10 22:13:04 2007 for libwireless by&nbsp;
+<hr size="1"><address style="align: right;"><small>Generated on Mon Sep 24 14:12:31 2007 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.6 </small></address>
 </body>