Index: xbee_8h.html
===================================================================
--- xbee_8h.html	(revision 78)
+++ xbee_8h.html	(revision 79)
@@ -27,7 +27,11 @@
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="ge6bb9bb274d6750f954762454807a5a7"></a><!-- doxytag: member="xbee.h::XBEE_PAN_DEFAULT" ref="ge6bb9bb274d6750f954762454807a5a7" args="" -->
 #define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#ge6bb9bb274d6750f954762454807a5a7">XBEE_PAN_DEFAULT</a>&nbsp;&nbsp;&nbsp;0xFFFF</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Do not change the PAN. <br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unset PAN, uses XBee default. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g35f8b9d8e01e788f1e29928cba29f215"></a><!-- doxytag: member="xbee.h::XBEE_CHANNEL_DEFAULT" ref="g35f8b9d8e01e788f1e29928cba29f215" args="" -->
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g35f8b9d8e01e788f1e29928cba29f215">XBEE_CHANNEL_DEFAULT</a>&nbsp;&nbsp;&nbsp;0</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unset channel, uses XBee default. <br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g93bbd21f7965e1697350f950cedff5c4"></a><!-- doxytag: member="xbee.h::XBEE_BROADCAST" ref="g93bbd21f7965e1697350f950cedff5c4" args="" -->
 #define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g93bbd21f7965e1697350f950cedff5c4">XBEE_BROADCAST</a>&nbsp;&nbsp;&nbsp;0xFFFF</td></tr>
 
@@ -53,9 +57,9 @@
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A packet received from another XBee. <br></td></tr>
 <tr><td colspan="2"><br><h2>Functions</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g2b86876f0e73bef20c4292810b15d4b9">xbee_lib_init</a> (int pan_id)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g334a723b79eccec83b17e25cde2e10f1">xbee_lib_init</a> (void)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the XBee library.  <a href="group__xbee.html#g2b86876f0e73bef20c4292810b15d4b9"></a><br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the XBee library.  <a href="group__xbee.html#g334a723b79eccec83b17e25cde2e10f1"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g9334ac71dca1ddd697b1a35a361ade6a">xbee_terminate</a> (void)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Uninitialize the XBee library.  <a href="group__xbee.html#g9334ac71dca1ddd697b1a35a361ade6a"></a><br></td></tr>
@@ -71,6 +75,12 @@
 <tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g7755cd8db87703c9e9943153660b8052">xbee_get_pan_id</a> (void)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the XBee's PAN ID.  <a href="group__xbee.html#g7755cd8db87703c9e9943153660b8052"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g33f2b13a8f46ee08f14bce90160a5623">xbee_set_channel</a> (int channel)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the channel the XBee is currently using.  <a href="group__xbee.html#g33f2b13a8f46ee08f14bce90160a5623"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g133706db81f69ba0a3c169b7a3f42d2a">xbee_get_channel</a> (void)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the channel the XBee is currently using.  <a href="group__xbee.html#g133706db81f69ba0a3c169b7a3f42d2a"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__xbee.html#g7c53e8a8492494a61ca306875d633309">xbee_get_address</a> (void)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the XBee's 16-bit address.  <a href="group__xbee.html#g7c53e8a8492494a61ca306875d633309"></a><br></td></tr>
@@ -80,7 +90,7 @@
 <p>
 Contains definitions for interfacing with the XBee module, from either a robot or a computer. To use a robot, define ROBOT in <a class="el" href="wl__defs_8h-source.html">wl_defs.h</a>, and to use a computer, don't define ROBOT.<p>
 <dl compact><dt><b>Author:</b></dt><dd>Brian Coltin, Colony Project, CMU Robotics Club </dd></dl>
-<hr size="1"><address style="align: right;"><small>Generated on Mon Sep 10 22:13:04 2007 for libwireless by&nbsp;
+<hr size="1"><address style="align: right;"><small>Generated on Mon Sep 24 14:12:30 2007 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.6 </small></address>
 </body>