commit 6ebee82cf91abf048eaf42a61093144dd1743693
Author: Alex <azirbel@andrew.cmu.edu>
Date:   Sat Mar 23 14:44:12 2013 -0400

    Moved all messages to the messages/ folder.
    
    This meant changing a lot of includes and things.

diff --git a/scout/buttons/CMakeLists.txt b/scout/buttons/CMakeLists.txt
index cf59d53..5338d76 100644
--- a/scout/buttons/CMakeLists.txt
+++ b/scout/buttons/CMakeLists.txt
@@ -17,7 +17,7 @@ set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
 set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
 
 #uncomment if you have defined messages
-rosbuild_genmsg()
+#rosbuild_genmsg()
 #uncomment if you have defined services
 #rosbuild_gensrv()
 
diff --git a/scout/buttons/manifest.xml b/scout/buttons/manifest.xml
index a75e0b2..2d9c2e5 100644
--- a/scout/buttons/manifest.xml
+++ b/scout/buttons/manifest.xml
@@ -9,6 +9,7 @@
   <url>https://www.roboticsclub.org/redmine/projects/colonyscout/wiki</url>
   <depend package="roscpp"/>
   <depend package="std_msgs"/>
+  <depend package="messages"/>
 
 </package>
 
diff --git a/scout/buttons/msg/button_event.msg b/scout/buttons/msg/button_event.msg
deleted file mode 100644
index 32eb646..0000000
--- a/scout/buttons/msg/button_event.msg
+++ /dev/null
@@ -1,2 +0,0 @@
-bool button1_pressed
-bool button2_pressed
diff --git a/scout/buttons/src/buttons.cpp b/scout/buttons/src/buttons.cpp
index 87bb03f..3e1326a 100644
--- a/scout/buttons/src/buttons.cpp
+++ b/scout/buttons/src/buttons.cpp
@@ -69,8 +69,8 @@ int main(int argc, char **argv)
     /* Advertise that this serves the query_buttons service */
     ros::NodeHandle n;
 
-    ros::Publisher pub = n.advertise<buttons::button_event>("button_event",
-                                                            QUEUE_SIZE);
+    ros::Publisher pub = n.advertise< ::messages::button_event>("button_event",
+                                                                QUEUE_SIZE);
 
     /* Initialize hardware for buttons */
     // Hardware init functions here
diff --git a/scout/buttons/src/buttons.h b/scout/buttons/src/buttons.h
index 9f870d7..dabb30d 100644
--- a/scout/buttons/src/buttons.h
+++ b/scout/buttons/src/buttons.h
@@ -38,7 +38,7 @@
 #ifndef _BUTTONS_H_
 #define _BUTTONS_H_
 
-#include "buttons/button_event.h"
+#include <messages/button_event.h>
 
 #define QUEUE_SIZE 10
 #define BUTTON_PRESSED 0x1
diff --git a/scout/encoders/CMakeLists.txt b/scout/encoders/CMakeLists.txt
index 7994c31..2f7cc8f 100644
--- a/scout/encoders/CMakeLists.txt
+++ b/scout/encoders/CMakeLists.txt
@@ -19,7 +19,7 @@ set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
 #uncomment if you have defined messages
 #rosbuild_genmsg()
 #uncomment if you have defined services
-rosbuild_gensrv()
+#rosbuild_gensrv()
 
 #common commands for building c++ executables and libraries
 #rosbuild_add_library(${PROJECT_NAME} src/example.cpp)
diff --git a/scout/encoders/manifest.xml b/scout/encoders/manifest.xml
index e75d879..adfbb9d 100644
--- a/scout/encoders/manifest.xml
+++ b/scout/encoders/manifest.xml
@@ -9,6 +9,7 @@
   <url>https://www.roboticsclub.org/redmine/projects/colonyscout/wiki</url>
   <depend package="roscpp"/>
   <depend package="std_msgs"/>
+  <depend package="messages"/>
 
 </package>
 
diff --git a/scout/encoders/src/encoders.cpp b/scout/encoders/src/encoders.cpp
index 5ac7cb6..ce32a53 100644
--- a/scout/encoders/src/encoders.cpp
+++ b/scout/encoders/src/encoders.cpp
@@ -35,7 +35,6 @@
  **/
 
 #include <ros/ros.h>
-
 #include "encoders.h"
 
 /**
@@ -89,8 +88,8 @@ int Encoder::get_ticks()
  * @param req The request. The units that the response should be in.
  * @param res The response. The fields will be filled with values.
  */
-bool handle_encoders_query(encoders::query_encoders::Request  &req,
-                           encoders::query_encoders::Response &res)
+bool handle_encoders_query(::messages::query_encoders::Request  &req,
+                           ::messages::query_encoders::Response &res)
 {
     /* Put index, velocity, and distance data in message */
     res.fl_distance = encoder_fl.get_ticks();
diff --git a/scout/encoders/src/encoders.h b/scout/encoders/src/encoders.h
index f7afa67..8ca834d 100644
--- a/scout/encoders/src/encoders.h
+++ b/scout/encoders/src/encoders.h
@@ -36,7 +36,7 @@
 #define _ENCODERS_H_
 
 #include <fstream>
-#include "encoders/query_encoders.h"
+#include <messages/query_encoders.h>
 
 class Encoder
 {
@@ -51,7 +51,7 @@ class Encoder
 int main(int argc, char **argv);
 
 /** @brief Responds to service to query encoder data **/
-bool handle_encoders_query(encoders::query_encoders::Request  &req,
-                           encoders::query_encoders::Response &res);
+bool handle_encoders_query(messages::query_encoders::Request  &req,
+                           messages::query_encoders::Response &res);
 
 #endif
diff --git a/scout/encoders/srv/query_encoders.srv b/scout/encoders/srv/query_encoders.srv
deleted file mode 100644
index 088ab4d..0000000
--- a/scout/encoders/srv/query_encoders.srv
+++ /dev/null
@@ -1,6 +0,0 @@
----
-# All units are simply in encoder ticks since encoders were turned on.
-uint32 fl_distance
-uint32 fr_distance
-uint32 bl_distance
-uint32 br_distance
diff --git a/scout/libscout/src/ButtonControl.cpp b/scout/libscout/src/ButtonControl.cpp
index 22f0381..896f9ac 100644
--- a/scout/libscout/src/ButtonControl.cpp
+++ b/scout/libscout/src/ButtonControl.cpp
@@ -60,7 +60,7 @@ ButtonControl::ButtonControl(const ros::NodeHandle& libscout_node,
  * @brief Respond to button events
  * Processes message and updates private variables
  */
-void ButtonControl::event_callback(const buttons::button_event::ConstPtr& msg)
+void ButtonControl::event_callback(const ::messages::button_event::ConstPtr& msg)
 {
     button1_value = msg->button1_pressed;
     button2_value = msg->button2_pressed;
diff --git a/scout/libscout/src/ButtonControl.h b/scout/libscout/src/ButtonControl.h
index 6107d46..6a51cad 100644
--- a/scout/libscout/src/ButtonControl.h
+++ b/scout/libscout/src/ButtonControl.h
@@ -36,7 +36,7 @@
  * @author Leon Zhang
  **/
 
-#include "buttons/button_event.h"
+#include "messages/button_event.h"
 #include "constants.h"
 
 #ifndef _LIBBUTTONS_H_
@@ -49,7 +49,7 @@ class ButtonControl
         ButtonControl(const ros::NodeHandle& libscout_node,
                       std::string scoutname);
 
-        void event_callback(const buttons::button_event::ConstPtr& msg);
+        void event_callback(const messages::button_event::ConstPtr& msg);
 
         bool button1_is_pressed();
         bool button2_is_pressed();
diff --git a/scout/libscout/src/EncodersControl.cpp b/scout/libscout/src/EncodersControl.cpp
index 28d65d5..0f4b2ce 100644
--- a/scout/libscout/src/EncodersControl.cpp
+++ b/scout/libscout/src/EncodersControl.cpp
@@ -43,7 +43,7 @@ EncodersControl::EncodersControl(const ros::NodeHandle& libscout_node,
     : node(libscout_node)
 {
     query_client =
-        node.serviceClient<encoders::query_encoders>(scoutname+"/query_encoders");
+        node.serviceClient< ::messages::query_encoders>(scoutname+"/query_encoders");
 }
 
 /**
@@ -52,7 +52,7 @@ EncodersControl::EncodersControl(const ros::NodeHandle& libscout_node,
 encoder_readings EncodersControl::query()
 {
     // Set scan range
-    encoders::query_encoders srv;
+    ::messages::query_encoders srv;
 
     encoder_readings cur_readings;
 
diff --git a/scout/libscout/src/EncodersControl.h b/scout/libscout/src/EncodersControl.h
index 52c0ef8..0cb8342 100644
--- a/scout/libscout/src/EncodersControl.h
+++ b/scout/libscout/src/EncodersControl.h
@@ -35,7 +35,7 @@
 #define _ENCODERS_CONTROL_H_
 
 #include <ros/ros.h>
-#include <encoders/query_encoders.h>
+#include <messages/query_encoders.h>
 
 #include "constants.h"
 
diff --git a/scout/libscout/src/LinesensorControl.cpp b/scout/libscout/src/LinesensorControl.cpp
index b1d47b6..bff934b 100644
--- a/scout/libscout/src/LinesensorControl.cpp
+++ b/scout/libscout/src/LinesensorControl.cpp
@@ -45,7 +45,7 @@ LinesensorControl::LinesensorControl(const ros::NodeHandle& libscout_node,
     : node(libscout_node)
 {
     query_client =
-        node.serviceClient<linesensor::query_linesensor>(scoutname+"/query_linesensor");
+        node.serviceClient< ::messages::query_linesensor>(scoutname+"/query_linesensor");
 }
 
 /**
@@ -54,7 +54,7 @@ LinesensorControl::LinesensorControl(const ros::NodeHandle& libscout_node,
 vector<uint32_t> LinesensorControl::query()
 {
     // Set scan range
-    linesensor::query_linesensor srv;
+    ::messages::query_linesensor srv;
 
     if (!query_client.call(srv))
     {
diff --git a/scout/libscout/src/LinesensorControl.h b/scout/libscout/src/LinesensorControl.h
index 9138581..be99c1d 100644
--- a/scout/libscout/src/LinesensorControl.h
+++ b/scout/libscout/src/LinesensorControl.h
@@ -35,7 +35,7 @@
 #define _LINESENSOR_CONTROL_H_
 
 #include <ros/ros.h>
-#include <linesensor/query_linesensor.h>
+#include <messages/query_linesensor.h>
 
 #include "constants.h"
 
diff --git a/scout/libscout/src/MotorControl.cpp b/scout/libscout/src/MotorControl.cpp
index fbc72e9..352aa0b 100644
--- a/scout/libscout/src/MotorControl.cpp
+++ b/scout/libscout/src/MotorControl.cpp
@@ -50,10 +50,10 @@ MotorControl::MotorControl(const ros::NodeHandle& libscout_node,
     : node(libscout_node)
 {
     set_motors_pub =
-        node.advertise<motors::set_motors>(scoutname + "/set_motors",
+        node.advertise< ::messages::set_motors>(scoutname + "/set_motors",
                                            QUEUE_SIZE, true);
     query_motors_client =
-        node.serviceClient<motors::query_motors>(scoutname + "/query_motors");
+        node.serviceClient< ::messages::query_motors>(scoutname + "/query_motors");
 }
 
 MotorControl::~MotorControl()
@@ -125,7 +125,7 @@ void MotorControl::set_each(int which,
 {
     check_which_ok(which);
 
-    motors::set_motors msg;
+    ::messages::set_motors msg;
 
 
     /* Tell the motors node which motors need to be updated */
@@ -223,7 +223,7 @@ int MotorControl::trim_speed(string which_str, int speed)
  */
 float MotorControl::query(int which)
 {
-    motors::query_motors srv;
+    ::messages::query_motors srv;
     if(query_motors_client.call(srv))
     {
         switch(which)
diff --git a/scout/libscout/src/MotorControl.h b/scout/libscout/src/MotorControl.h
index 1435566..7781419 100644
--- a/scout/libscout/src/MotorControl.h
+++ b/scout/libscout/src/MotorControl.h
@@ -39,8 +39,8 @@
 #define _MOTOR_CONTROL_H_
 
 #include <ros/ros.h>
-#include <motors/query_motors.h>
-#include <motors/set_motors.h>
+#include <messages/query_motors.h>
+#include <messages/set_motors.h>
 
 #include "constants.h"
 
diff --git a/scout/linesensor/CMakeLists.txt b/scout/linesensor/CMakeLists.txt
index 0439f61..af11054 100644
--- a/scout/linesensor/CMakeLists.txt
+++ b/scout/linesensor/CMakeLists.txt
@@ -19,7 +19,7 @@ set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
 #uncomment if you have defined messages
 #rosbuild_genmsg()
 #uncomment if you have defined services
-rosbuild_gensrv()
+#rosbuild_gensrv()
 
 #common commands for building c++ executables and libraries
 #rosbuild_add_library(${PROJECT_NAME} src/example.cpp)
diff --git a/scout/linesensor/manifest.xml b/scout/linesensor/manifest.xml
index dd1ebb5..b60d39e 100644
--- a/scout/linesensor/manifest.xml
+++ b/scout/linesensor/manifest.xml
@@ -10,6 +10,7 @@
   <url>https://www.roboticsclub.org/redmine/projects/colonyscout/wiki</url>
   <depend package="roscpp"/>
   <depend package="std_msgs"/>
+  <depend package="messages"/>
 
 </package>
 
diff --git a/scout/linesensor/srv/query_linesensor.srv b/scout/linesensor/srv/query_linesensor.srv
deleted file mode 100644
index 657e40a..0000000
--- a/scout/linesensor/srv/query_linesensor.srv
+++ /dev/null
@@ -1,3 +0,0 @@
----
-# 10-bit unsigned integers, 0 is perfectly white.
-uint32[] readings
diff --git a/scout/motors/CMakeLists.txt b/scout/motors/CMakeLists.txt
index 600778c..9918b0d 100644
--- a/scout/motors/CMakeLists.txt
+++ b/scout/motors/CMakeLists.txt
@@ -17,9 +17,9 @@ set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
 set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
 
 #uncomment if you have defined messages
-rosbuild_genmsg()
+#rosbuild_genmsg()
 #uncomment if you have defined services
-rosbuild_gensrv()
+#rosbuild_gensrv()
 
 #common commands for building c++ executables and libraries
 #rosbuild_add_library(${PROJECT_NAME} src/example.cpp)
diff --git a/scout/motors/manifest.xml b/scout/motors/manifest.xml
index a2775b2..2e99f68 100644
--- a/scout/motors/manifest.xml
+++ b/scout/motors/manifest.xml
@@ -9,6 +9,7 @@
   <url>https://www.roboticsclub.org/redmine/projects/colonyscout/wiki</url>
   <depend package="roscpp"/>
   <depend package="std_msgs"/>
+  <depend package="messages"/>
 
   <export>
     <cpp cflags="-I${prefix}/include" lflags="-Wl,-rpath,${prefix}/lib -L${prefix}/lib"/>
diff --git a/scout/motors/msg/set_motors.msg b/scout/motors/msg/set_motors.msg
deleted file mode 100644
index 0fd045c..0000000
--- a/scout/motors/msg/set_motors.msg
+++ /dev/null
@@ -1,15 +0,0 @@
-# Set these to true if the motor should be updated
-bool fl_set
-bool fr_set
-bool bl_set
-bool br_set
-bool teleop_ON
-
-# The absolute motor speeds to set
-int8 fl_speed
-int8 fr_speed
-int8 bl_speed
-int8 br_speed
-
-int8 MAX_SPEED = 100
-int8 MIN_SPEED = -100
diff --git a/scout/motors/src/motors.cpp b/scout/motors/src/motors.cpp
index 97804aa..d3086ac 100644
--- a/scout/motors/src/motors.cpp
+++ b/scout/motors/src/motors.cpp
@@ -154,7 +154,7 @@ static Motor motor_br(10, 76, 77);
  * @param msg The message from the set_motors topic, containing speeds and
  *  motor configuration settings.
  */
-void motors_set(const motors::set_motors::ConstPtr& msg)
+void motors_set(const ::messages::set_motors::ConstPtr& msg)
 {
     if(msg->fl_set)
     {
@@ -184,8 +184,8 @@ void motors_set(const motors::set_motors::ConstPtr& msg)
  * @param req The request. The only field is the units requested.
  * @param res The response. The fields will be filled with values.
  */
-bool motors_query(motors::query_motors::Request &req,
-                  motors::query_motors::Response &res)
+bool motors_query(::messages::query_motors::Request &req,
+                  ::messages::query_motors::Response &res)
 {
     res.fl_speed = motor_fl.get_speed();
     res.fr_speed = motor_fr.get_speed();
diff --git a/scout/motors/src/motors.h b/scout/motors/src/motors.h
index 65812a5..6ef0a46 100644
--- a/scout/motors/src/motors.h
+++ b/scout/motors/src/motors.h
@@ -40,8 +40,8 @@
 #define _MOTORS_H_
 
 #include <fstream>
-#include <motors/set_motors.h>
-#include <motors/query_motors.h>
+#include <messages/set_motors.h>
+#include <messages/query_motors.h>
 
 #define QUEUE_SIZE 10
 
@@ -49,11 +49,11 @@
 int main(int argc, char **argv);
 
 /** @brief Responds to topic to set motor speeds and configs. **/
-void motors_set(const motors::set_motors::ConstPtr& msg);
+void motors_set(const messages::set_motors::ConstPtr& msg);
 
 /** @brief Responds to service to query motor speeds. **/
-bool motors_query(motors::query_motors::Request &req,
-                  motors::query_motors::Response &res);
+bool motors_query(messages::query_motors::Request &req,
+                  messages::query_motors::Response &res);
 
 class Motor
 {
diff --git a/scout/motors/srv/query_motors.srv b/scout/motors/srv/query_motors.srv
deleted file mode 100644
index 6db1530..0000000
--- a/scout/motors/srv/query_motors.srv
+++ /dev/null
@@ -1,5 +0,0 @@
----
-int8 fl_speed
-int8 fr_speed
-int8 bl_speed
-int8 br_speed
diff --git a/scout/power/CMakeLists.txt b/scout/power/CMakeLists.txt
index 149c66e..bcf183d 100644
--- a/scout/power/CMakeLists.txt
+++ b/scout/power/CMakeLists.txt
@@ -17,9 +17,9 @@ set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
 set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
 
 #uncomment if you have defined messages
-rosbuild_genmsg()
+#rosbuild_genmsg()
 #uncomment if you have defined services
-rosbuild_gensrv()
+#rosbuild_gensrv()
 
 #common commands for building c++ executables and libraries
 #rosbuild_add_library(${PROJECT_NAME} src/example.cpp)
diff --git a/scout/power/manifest.xml b/scout/power/manifest.xml
index 2e105aa..1d892d6 100644
--- a/scout/power/manifest.xml
+++ b/scout/power/manifest.xml
@@ -9,6 +9,7 @@
   <url>https://www.roboticsclub.org/redmine/projects/colonyscout/wiki</url>
   <depend package="roscpp"/>
   <depend package="std_msgs"/>
+  <depend package="messages"/>
 
 </package>
 
diff --git a/scout/power/msg/power_state_changed.msg b/scout/power/msg/power_state_changed.msg
deleted file mode 100644
index af9ffb9..0000000
--- a/scout/power/msg/power_state_changed.msg
+++ /dev/null
@@ -1,13 +0,0 @@
-#32-bit integer with current voltage info
-uint32 voltage
-#power percentage [0-100]
-uint32 percentage
-#current draw in mW
-uint32 draw
-#are we on external power?
-bool externalpower
-#is the battery at a warning state?
-bool warning
-#is the battery at a critical state?
-bool critical
-
diff --git a/scout/power/src/power.cpp b/scout/power/src/power.cpp
index 3a12bbf..4876ec2 100644
--- a/scout/power/src/power.cpp
+++ b/scout/power/src/power.cpp
@@ -71,8 +71,8 @@ bool critical; /**< is the battery reporting a critical state? */
  * @param req The request. There are no fields
  * @param res The response. The fields will be filled with values.
  */
-bool power_query(power::query_power::Request &req,
-                  power::query_power::Response &res)
+bool power_query(::messages::query_power::Request &req,
+                 ::messages::query_power::Response &res)
 {
     res.voltage = voltage;
     res.percentage = percentage;
diff --git a/scout/power/src/power.h b/scout/power/src/power.h
index 69ecc8f..5396826 100644
--- a/scout/power/src/power.h
+++ b/scout/power/src/power.h
@@ -37,14 +37,14 @@
 #ifndef _POWER_H_
 #define _POWER_H_
 
-#include "power/query_power.h"
+#include <messages/query_power.h>
 
 /** @brief Initialize the power module and driver. **/
 int main(int argc, char **argv);
 
 /** @brief Responds to service to query power informatio **/
-bool power_query(power::query_power::Request &req,
-                  power::query_power::Response &res);
+bool power_query(messages::query_power::Request &req,
+                 messages::query_power::Response &res);
 
 /** @breif Function that sends the power_state_changed message **/
 void send_power_state_changed();
diff --git a/scout/power/srv/query_power.srv b/scout/power/srv/query_power.srv
deleted file mode 100644
index aeaa127..0000000
--- a/scout/power/srv/query_power.srv
+++ /dev/null
@@ -1,13 +0,0 @@
----
-#32-bit integer with current voltage info
-uint32 voltage
-#power percentage [0-100]
-uint32 percentage
-#current draw in mW
-uint32 draw
-#are we on external power?
-bool externalpower
-#is the battery at a warning state?
-bool warning
-#is the battery at a critical state?
-bool critical
diff --git a/scout/scoutsim/manifest.xml b/scout/scoutsim/manifest.xml
index 243027a..8133573 100644
--- a/scout/scoutsim/manifest.xml
+++ b/scout/scoutsim/manifest.xml
@@ -13,9 +13,6 @@
   <depend package="roslib"/>
   <depend package="rosconsole"/>
   <depend package="std_srvs"/>
-  <depend package="motors" />
-  <depend package="encoders" />
-  <depend package="linesensor" />
   <depend package="geometry_msgs" />
   <depend package="messages"/>
   
@@ -34,8 +31,6 @@
     <depend package="roslib"/>
     <depend package="rosconsole"/>
     <depend package="std_srvs"/>
-    <depend package="motors" />
-    <depend package="encoders" />
     <depend package="geometry_msgs" />
     <depend package="messages"/>
 
diff --git a/scout/scoutsim/src/scout.cpp b/scout/scoutsim/src/scout.cpp
index 140eadc..9251426 100644
--- a/scout/scoutsim/src/scout.cpp
+++ b/scout/scoutsim/src/scout.cpp
@@ -134,7 +134,7 @@ namespace scoutsim
      * request.
      * @todo Use "callback" in all callback function names? Or remove?
      */
-    void Scout::setMotors(const motors::set_motors::ConstPtr& msg)
+    void Scout::setMotors(const ::messages::set_motors::ConstPtr& msg)
     {
         last_command_time = ros::WallTime::now();
 
@@ -244,8 +244,8 @@ namespace scoutsim
         return true;
     }
 
-    bool Scout::query_encoders_callback(encoders::query_encoders::Request&,
-                                        encoders::query_encoders::Response& res)
+    bool Scout::query_encoders_callback(::messages::query_encoders::Request&,
+                                        ::messages::query_encoders::Response& res)
     {
         res.fl_distance = fl_ticks;
         res.fr_distance = fr_ticks;
@@ -255,8 +255,8 @@ namespace scoutsim
         return true;
     }
 
-    bool Scout::query_linesensor_callback(linesensor::query_linesensor::Request&,
-                                          linesensor::query_linesensor::Response& res)
+    bool Scout::query_linesensor_callback(::messages::query_linesensor::Request&,
+                                          ::messages::query_linesensor::Response& res)
     {
         res.readings = linesensor_readings;
 
diff --git a/scout/scoutsim/src/scout.h b/scout/scoutsim/src/scout.h
index 1011ef4..a3b654a 100644
--- a/scout/scoutsim/src/scout.h
+++ b/scout/scoutsim/src/scout.h
@@ -52,9 +52,9 @@
 #include <vector>
 #include <boost/shared_ptr.hpp>
 
-#include <motors/set_motors.h>
-#include <encoders/query_encoders.h>
-#include <linesensor/query_linesensor.h>
+#include <messages/set_motors.h>
+#include <messages/query_encoders.h>
+#include <messages/query_linesensor.h>
 #include <messages/sonar_distance.h>
 #include <messages/sonar_toggle.h>
 #include <messages/sonar_set_scan.h>
@@ -124,17 +124,17 @@ namespace scoutsim
 
         private:
             float absolute_to_mps(int absolute_speed);
-            void setMotors(const motors::set_motors::ConstPtr& msg);
+            void setMotors(const messages::set_motors::ConstPtr& msg);
             bool setPenCallback(scoutsim::SetPen::Request&,
                                 scoutsim::SetPen::Response&);
-            bool query_encoders_callback(encoders::query_encoders::Request&,
-                                         encoders::query_encoders::Response&);
-            bool query_linesensor_callback(linesensor::query_linesensor::Request&,
-                                           linesensor::query_linesensor::Response&);
+            bool query_encoders_callback(messages::query_encoders::Request&,
+                                     messages::query_encoders::Response&);
+            bool query_linesensor_callback(messages::query_linesensor::Request&,
+                                     messages::query_linesensor::Response&);
             bool handle_sonar_toggle(messages::sonar_toggle::Request  &req,
                                      messages::sonar_toggle::Response &res);
             bool handle_sonar_set_scan(messages::sonar_set_scan::Request  &req,
-                                       messages::sonar_set_scan::Response &res);
+                                     messages::sonar_set_scan::Response &res);
             unsigned int rgb_to_grey(unsigned char r,
                                      unsigned char g,
                                      unsigned char b);
diff --git a/scout/scoutsim/src/scout_constants.h b/scout/scoutsim/src/scout_constants.h
index aeb2100..cdb276b 100644
--- a/scout/scoutsim/src/scout_constants.h
+++ b/scout/scoutsim/src/scout_constants.h
@@ -48,7 +48,7 @@
 #ifndef _SCOUTSIM_SCOUT_CONSTANTS_
 #define _SCOUTSIM_SCOUT_CONSTANTS_
 
-#include <motors/set_motors.h>
+#include <messages/set_motors.h>
 
 /// TODO put these in a utility file somewhere?
 #define min(x,y) ((x < y) ? x : y)
@@ -57,8 +57,8 @@
 namespace scoutsim
 {
     // Maximum speed which will be sent to scoutsim in absolute units
-    const int MAX_ABSOLUTE_SPEED = motors::set_motors::MAX_SPEED;
-    const int MIN_ABSOLUTE_SPEED = motors::set_motors::MIN_SPEED;
+    const int MAX_ABSOLUTE_SPEED = messages::set_motors::MAX_SPEED;
+    const int MIN_ABSOLUTE_SPEED = messages::set_motors::MIN_SPEED;
 
     // Speed in m/s corresponding to maximum absolute speed
     const float MAX_SPEED_MPS = 1.0;
diff --git a/scout/scoutsim/src/sim_frame.cpp b/scout/scoutsim/src/sim_frame.cpp
index d0a6c89..b944ff5 100644
--- a/scout/scoutsim/src/sim_frame.cpp
+++ b/scout/scoutsim/src/sim_frame.cpp
@@ -132,7 +132,7 @@ namespace scoutsim
         teleop_r_speed = 0;
         teleop_scoutname = "scout1";
 
-        teleop_pub = nh.advertise<motors::set_motors>("/scout1/set_motors", 1000);
+        teleop_pub = nh.advertise< ::messages::set_motors>("/scout1/set_motors", 1000);
 
         ROS_INFO("Starting scoutsim with node name %s",
                  ros::this_node::getName().c_str()) ;
@@ -241,7 +241,7 @@ namespace scoutsim
     {
         std::stringstream ss;
         ss << "/" << req.scout_name << "/set_motors";
-        teleop_pub = nh.advertise<motors::set_motors>(ss.str(), 1000);
+        teleop_pub = nh.advertise< ::messages::set_motors>(ss.str(), 1000);
         teleop_scoutname = req.scout_name.c_str();
         ROS_INFO("Teleoping %s...",teleop_scoutname.c_str()); //debug statement
 
@@ -532,7 +532,7 @@ namespace scoutsim
                 break;
         }
 
-        motors::set_motors msg;
+        ::messages::set_motors msg;
         msg.fl_set = true;
         msg.fr_set = true;
         msg.bl_set = true;
diff --git a/scout/scoutsim/src/sim_frame.h b/scout/scoutsim/src/sim_frame.h
index 2627db9..cf9d56c 100644
--- a/scout/scoutsim/src/sim_frame.h
+++ b/scout/scoutsim/src/sim_frame.h
@@ -61,7 +61,7 @@
 #include <scoutsim/SetSonarViz.h>
 #include <scoutsim/SetGhost.h>
 #include <scoutsim/SetTeleop.h>
-#include <motors/set_motors.h>
+#include <messages/set_motors.h>
 #include <map>
 
 #include "scout.h"