commit b86c7eb9c1c0a4948fb705e314d9a44814df2717
Author: Jess Chernak <jchernak@andrew.cmu.edu>
Date:   Wed May 7 23:14:17 2014 -0400

    finished routing motor controllers

diff --git a/scoutshield/scoutshield_v1.brd b/scoutshield/scoutshield_v1.brd
index 036b745..fba1bb7 100644
--- a/scoutshield/scoutshield_v1.brd
+++ b/scoutshield/scoutshield_v1.brd
@@ -1104,13 +1104,13 @@ design rules under a new name.</description>
 <element name="C49" library="SparkFun" package="0603-CAP" value="0.1uF" x="86.233" y="37.338" rot="MR270"/>
 <element name="C50" library="SparkFun" package="0603-CAP" value="100nF" x="87.122" y="45.339" rot="MR270"/>
 <element name="U$6" library="scout" package="WSON-12" value="DRV8835" x="54.229" y="47.244"/>
-<element name="U$7" library="SparkFun" package="SOT223" value="V_REG_317SMD" x="53.34" y="39.37" rot="R180"/>
-<element name="R1" library="rcl" package="R2512" value="0.8, &gt; 1W" x="59.69" y="41.91" rot="R90"/>
-<element name="C5" library="SparkFun" package="0603-CAP" value="0.1uF" x="15.24" y="25.4"/>
+<element name="U$7" library="SparkFun" package="SOT223" value="V_REG_317SMD" x="49.911" y="41.402" rot="R180"/>
+<element name="R1" library="rcl" package="R2512" value="0.8, &gt; 1W" x="55.372" y="40.005" rot="R270"/>
+<element name="C5" library="SparkFun" package="0603-CAP" value="0.1uF" x="35.306" y="45.466" rot="R180"/>
 <element name="U$5" library="scout" package="WSON-12" value="DRV8835" x="43.18" y="47.244"/>
-<element name="U$8" library="SparkFun" package="SOT223" value="V_REG_317SMD" x="19.05" y="43.18"/>
-<element name="R3" library="rcl" package="R2512" value="0.8, &gt; 1W" x="31.75" y="36.83"/>
-<element name="C6" library="SparkFun" package="0603-CAP" value="0.1uF" x="11.43" y="44.45" rot="R180"/>
+<element name="U$8" library="SparkFun" package="SOT223" value="V_REG_317SMD" x="37.465" y="40.64" rot="R90"/>
+<element name="R3" library="rcl" package="R2512" value="0.8, &gt; 1W" x="43.815" y="39.878" rot="R270"/>
+<element name="C6" library="SparkFun" package="0603-CAP" value="0.1uF" x="38.481" y="45.466" rot="R180"/>
 </elements>
 <signals>
 <signal name="RES">
@@ -1208,7 +1208,6 @@ design rules under a new name.</description>
 <wire x1="41.78" y1="46.994" x2="43.18" y2="46.994" width="0.254" layer="1"/>
 <wire x1="44.58" y1="46.994" x2="43.18" y2="46.994" width="0.254" layer="1"/>
 <wire x1="43.18" y1="46.994" x2="43.18" y2="47.244" width="0.254" layer="1"/>
-<wire x1="52.829" y1="46.99" x2="44.58" y2="46.99" width="0.254" layer="1"/>
 <wire x1="44.58" y1="46.99" x2="44.58" y2="46.994" width="0.254" layer="1"/>
 <wire x1="52.829" y1="46.99" x2="52.829" y2="46.994" width="0.254" layer="1"/>
 <wire x1="55.629" y1="46.994" x2="54.229" y2="46.994" width="0.254" layer="1"/>
@@ -1225,14 +1224,6 @@ design rules under a new name.</description>
 <wire x1="43.18" y1="47.244" x2="43.18" y2="46.99" width="0.254" layer="1"/>
 <wire x1="44.58" y1="47.494" x2="43.18" y2="47.494" width="0.254" layer="1"/>
 <wire x1="43.18" y1="47.494" x2="43.18" y2="47.244" width="0.254" layer="1"/>
-<wire x1="26.67" y1="50.673" x2="26.67" y2="50.927" width="0.254" layer="16"/>
-<wire x1="26.67" y1="50.927" x2="28.321" y2="52.578" width="0.254" layer="16"/>
-<wire x1="28.321" y1="52.578" x2="37.592" y2="52.578" width="0.254" layer="16"/>
-<wire x1="37.592" y1="52.578" x2="38.1" y2="52.07" width="0.254" layer="16"/>
-<wire x1="38.1" y1="52.07" x2="38.1" y2="47.879" width="0.254" layer="16"/>
-<wire x1="38.1" y1="47.879" x2="38.989" y2="46.99" width="0.254" layer="16"/>
-<via x="38.989" y="46.99" extent="1-16" drill="0.6"/>
-<wire x1="38.989" y1="46.99" x2="41.776" y2="46.99" width="0.254" layer="1"/>
 <wire x1="41.776" y1="46.99" x2="41.78" y2="46.994" width="0.254" layer="1"/>
 <wire x1="86.162" y1="47.189" x2="86.812" y2="47.189" width="0.4064" layer="1"/>
 <wire x1="86.812" y1="47.189" x2="87.462" y2="47.189" width="0.4064" layer="1"/>
@@ -1296,9 +1287,24 @@ design rules under a new name.</description>
 <wire x1="80.01" y1="33.02" x2="77.47" y2="35.56" width="0.254" layer="1"/>
 <wire x1="77.47" y1="35.56" x2="77.47" y2="36.263" width="0.254" layer="1"/>
 <wire x1="77.47" y1="36.263" x2="77.322" y2="36.411" width="0.254" layer="1"/>
+<wire x1="41.78" y1="46.994" x2="41.279" y2="46.994" width="0.4064" layer="1"/>
+<wire x1="41.279" y1="46.994" x2="41.021" y2="46.736" width="0.4064" layer="1"/>
+<wire x1="44.58" y1="46.99" x2="52.825" y2="46.99" width="0.4064" layer="1"/>
+<wire x1="52.825" y1="46.99" x2="52.829" y2="46.994" width="0.4064" layer="1"/>
+<wire x1="41.021" y1="46.736" x2="39.116" y2="46.736" width="0.4064" layer="1"/>
+<via x="39.116" y="46.736" extent="1-16" drill="0.6"/>
+<wire x1="39.116" y1="46.736" x2="39.37" y2="46.99" width="0.4064" layer="2"/>
+<wire x1="39.37" y1="46.99" x2="38.862" y2="46.99" width="0.4064" layer="2"/>
+<wire x1="38.862" y1="46.99" x2="38.735" y2="46.863" width="0.4064" layer="2"/>
+<wire x1="37.631" y1="45.466" x2="37.631" y2="46.14" width="0.254" layer="1"/>
+<wire x1="37.631" y1="46.14" x2="38.227" y2="46.736" width="0.254" layer="1"/>
+<wire x1="38.227" y1="46.736" x2="39.116" y2="46.736" width="0.254" layer="1"/>
+<wire x1="34.456" y1="45.466" x2="34.456" y2="46.267" width="0.4064" layer="1"/>
+<wire x1="34.456" y1="46.267" x2="34.925" y2="46.736" width="0.4064" layer="1"/>
+<via x="34.925" y="46.736" extent="1-16" drill="0.6"/>
+<wire x1="34.925" y1="46.736" x2="35.052" y2="46.736" width="0.4064" layer="2"/>
+<wire x1="35.052" y1="46.736" x2="35.179" y2="46.863" width="0.4064" layer="2"/>
 <wire x1="87.674" y1="36.488" x2="87.63" y2="36.488" width="0" layer="19" extent="16-16"/>
-<wire x1="16.09" y1="25.4" x2="7.62" y2="24.13" width="0" layer="19" extent="1-1"/>
-<wire x1="10.58" y1="44.45" x2="26.67" y2="50.673" width="0" layer="19" extent="1-1"/>
 </signal>
 <signal name="VIN">
 <polygon width="0.4064" layer="15">
@@ -1317,6 +1323,39 @@ design rules under a new name.</description>
 <wire x1="5.08" y1="17.78" x2="5.08" y2="17.91" width="0.4064" layer="1"/>
 <wire x1="7.62" y1="26.8" x2="7.62" y2="28.7528" width="0.4064" layer="1"/>
 <wire x1="7.62" y1="28.7528" x2="6.0452" y2="30.3276" width="0.4064" layer="1"/>
+<contactref element="U$8" pad="3"/>
+<contactref element="C6" pad="1"/>
+<contactref element="U$7" pad="3"/>
+<contactref element="C5" pad="1"/>
+<via x="40.767" y="45.593" extent="1-16" drill="0.6"/>
+<via x="46.228" y="45.847" extent="1-16" drill="0.6"/>
+<wire x1="47.3202" y1="44.5008" x2="47.5996" y2="44.5008" width="0.254" layer="1"/>
+<wire x1="40.767" y1="45.593" x2="45.974" y2="45.593" width="0.254" layer="16"/>
+<wire x1="45.974" y1="45.593" x2="46.228" y2="45.847" width="0.254" layer="16"/>
+<wire x1="40.5638" y1="42.9514" x2="40.5638" y2="45.3898" width="0.4064" layer="1"/>
+<wire x1="40.5638" y1="45.3898" x2="40.767" y2="45.593" width="0.4064" layer="1"/>
+<wire x1="36.156" y1="45.466" x2="36.156" y2="46.316" width="0.4064" layer="1"/>
+<wire x1="36.156" y1="46.316" x2="36.703" y2="46.863" width="0.4064" layer="1"/>
+<via x="36.703" y="46.863" extent="1-16" drill="0.6"/>
+<wire x1="40.5638" y1="45.3898" x2="39.4072" y2="45.3898" width="0.4064" layer="1"/>
+<wire x1="39.4072" y1="45.3898" x2="39.331" y2="45.466" width="0.4064" layer="1"/>
+<wire x1="39.331" y1="45.466" x2="39.331" y2="44.538" width="0.4064" layer="1"/>
+<wire x1="39.331" y1="44.538" x2="39.116" y2="44.323" width="0.4064" layer="1"/>
+<wire x1="39.116" y1="44.323" x2="36.449" y2="44.323" width="0.4064" layer="1"/>
+<wire x1="36.449" y1="44.323" x2="36.195" y2="44.577" width="0.4064" layer="1"/>
+<wire x1="36.195" y1="44.577" x2="36.195" y2="45.427" width="0.4064" layer="1"/>
+<wire x1="36.195" y1="45.427" x2="36.156" y2="45.466" width="0.4064" layer="1"/>
+<wire x1="47.3202" y1="44.5008" x2="46.6852" y2="44.5008" width="0.4064" layer="1"/>
+<wire x1="46.6852" y1="44.5008" x2="46.228" y2="44.958" width="0.4064" layer="1"/>
+<wire x1="46.228" y1="44.958" x2="46.228" y2="45.847" width="0.4064" layer="1"/>
+<wire x1="22.479" y1="49.657" x2="22.479" y2="49.784" width="0.4064" layer="15"/>
+<wire x1="22.479" y1="49.784" x2="22.352" y2="49.911" width="0.4064" layer="15"/>
+<wire x1="36.703" y1="46.863" x2="36.703" y2="48.006" width="0.4064" layer="16"/>
+<wire x1="36.703" y1="48.006" x2="35.433" y2="49.276" width="0.4064" layer="16"/>
+<wire x1="35.433" y1="49.276" x2="22.86" y2="49.276" width="0.4064" layer="16"/>
+<wire x1="22.86" y1="49.276" x2="22.479" y2="49.657" width="0.4064" layer="16"/>
+<via x="22.479" y="49.657" extent="1-16" drill="0.6"/>
+<wire x1="22.479" y1="49.657" x2="22.479" y2="49.022" width="0.4064" layer="15"/>
 </signal>
 <signal name="A0">
 <contactref element="JP7" pad="1"/>
@@ -1624,10 +1663,6 @@ design rules under a new name.</description>
 <wire x1="52.578" y1="52.578" x2="65.532" y2="52.578" width="0.254" layer="16"/>
 <wire x1="65.532" y1="52.578" x2="66.04" y2="52.07" width="0.254" layer="16"/>
 <via x="66.04" y="52.07" extent="1-16" drill="0.6"/>
-<wire x1="40.64" y1="51.943" x2="40.64" y2="48.321" width="0.254" layer="16"/>
-<wire x1="40.64" y1="48.321" x2="40.259" y2="47.94" width="0.254" layer="16"/>
-<wire x1="41.93" y1="48.194" x2="40.513" y2="48.194" width="0.254" layer="1"/>
-<wire x1="40.513" y1="48.194" x2="40.259" y2="47.94" width="0.254" layer="1"/>
 <wire x1="52.07" y1="52.07" x2="52.578" y2="52.578" width="0.254" layer="16"/>
 <wire x1="52.07" y1="52.07" x2="52.07" y2="48.895" width="0.254" layer="16"/>
 <wire x1="52.07" y1="48.895" x2="51.435" y2="48.26" width="0.254" layer="16"/>
@@ -1663,6 +1698,10 @@ design rules under a new name.</description>
 <wire x1="77.322" y1="37.611" x2="77.832" y2="37.611" width="0.254" layer="1"/>
 <wire x1="77.832" y1="37.611" x2="78.232" y2="37.211" width="0.254" layer="1"/>
 <wire x1="78.232" y1="37.211" x2="79.142" y2="37.211" width="0.254" layer="1"/>
+<wire x1="41.93" y1="48.194" x2="40.513" y2="48.194" width="0.254" layer="1"/>
+<wire x1="40.513" y1="48.194" x2="40.259" y2="47.94" width="0.254" layer="1"/>
+<wire x1="40.64" y1="51.943" x2="40.64" y2="48.321" width="0.254" layer="16"/>
+<wire x1="40.64" y1="48.321" x2="40.259" y2="47.94" width="0.254" layer="16"/>
 </signal>
 <signal name="+5V">
 <contactref element="U$1" pad="VOUT"/>
@@ -1761,26 +1800,26 @@ design rules under a new name.</description>
 <wire x1="93.091" y1="44.45" x2="95.123" y2="44.45" width="0.254" layer="1"/>
 <wire x1="95.123" y1="44.45" x2="96.393" y2="45.72" width="0.254" layer="1"/>
 </signal>
-<signal name="VCC">
-<contactref element="U$7" pad="3"/>
-<contactref element="C5" pad="1"/>
-<contactref element="U$8" pad="3"/>
-<contactref element="C6" pad="1"/>
-<wire x1="21.3614" y1="40.0812" x2="51.0286" y2="42.4688" width="0" layer="19" extent="1-1"/>
-<wire x1="12.28" y1="44.45" x2="21.3614" y2="40.0812" width="0" layer="19" extent="1-1"/>
-<wire x1="14.39" y1="25.4" x2="21.3614" y2="40.0812" width="0" layer="19" extent="1-1"/>
-</signal>
 <signal name="N$1">
 <contactref element="U$7" pad="1"/>
 <contactref element="R1" pad="1"/>
 <contactref element="U$6" pad="P1"/>
-<wire x1="55.6514" y1="42.4688" x2="59.69" y2="39.11" width="0" layer="19" extent="1-1"/>
-<wire x1="52.979" y1="46.294" x2="55.6514" y2="42.4688" width="0" layer="19" extent="1-1"/>
+<wire x1="52.979" y1="46.294" x2="52.979" y2="45.867" width="0.4064" layer="1"/>
+<wire x1="52.979" y1="45.867" x2="52.197" y2="45.085" width="0.4064" layer="1"/>
+<wire x1="52.197" y1="45.085" x2="52.197" y2="44.5262" width="0.4064" layer="1"/>
+<wire x1="52.197" y1="44.5262" x2="52.2224" y2="44.5008" width="0.4064" layer="1"/>
+<wire x1="52.2224" y1="44.5008" x2="54.8132" y2="44.5008" width="0.4064" layer="1"/>
+<wire x1="54.8132" y1="44.5008" x2="55.372" y2="43.942" width="0.4064" layer="1"/>
+<wire x1="55.372" y1="43.942" x2="55.372" y2="42.805" width="0.4064" layer="1"/>
 </signal>
 <signal name="N$2">
 <contactref element="U$7" pad="2"/>
 <contactref element="R1" pad="2"/>
-<wire x1="53.34" y1="42.4688" x2="59.69" y2="44.71" width="0" layer="19" extent="1-1"/>
+<wire x1="55.372" y1="37.205" x2="55.372" y2="38.989" width="0.4064" layer="1"/>
+<wire x1="55.372" y1="38.989" x2="51.943" y2="42.418" width="0.4064" layer="1"/>
+<wire x1="51.943" y1="42.418" x2="50.292" y2="42.418" width="0.4064" layer="1"/>
+<wire x1="50.292" y1="42.418" x2="49.911" y2="42.799" width="0.4064" layer="1"/>
+<wire x1="49.911" y1="42.799" x2="49.911" y2="44.5008" width="0.4064" layer="1"/>
 </signal>
 <signal name="MOTOR1+">
 <contactref element="U$6" pad="P2"/>
@@ -1799,10 +1838,6 @@ design rules under a new name.</description>
 <contactref element="U$5" pad="P11"/>
 <contactref element="JP3" pad="3"/>
 <wire x1="36.83" y1="50.673" x2="37.592" y2="50.673" width="0.254" layer="1"/>
-<wire x1="37.592" y1="50.673" x2="39.37" y2="48.895" width="0.254" layer="1"/>
-<wire x1="39.37" y1="48.895" x2="42.164" y2="48.895" width="0.254" layer="1"/>
-<wire x1="42.164" y1="48.895" x2="42.418" y2="48.641" width="0.254" layer="1"/>
-<wire x1="42.418" y1="48.641" x2="42.418" y2="48.206" width="0.254" layer="1"/>
 <wire x1="42.418" y1="48.206" x2="42.43" y2="48.194" width="0.254" layer="1"/>
 <wire x1="50.673" y1="49.149" x2="49.53" y2="50.292" width="0.254" layer="1"/>
 <wire x1="49.53" y1="50.292" x2="49.53" y2="52.07" width="0.254" layer="1"/>
@@ -1814,6 +1849,10 @@ design rules under a new name.</description>
 <wire x1="53.479" y1="48.756" x2="53.34" y2="48.895" width="0.254" layer="1"/>
 <wire x1="53.34" y1="48.895" x2="52.07" y2="48.895" width="0.254" layer="1"/>
 <wire x1="52.07" y1="48.895" x2="51.816" y2="49.149" width="0.254" layer="1"/>
+<wire x1="37.592" y1="50.673" x2="39.37" y2="48.895" width="0.254" layer="1"/>
+<wire x1="42.418" y1="48.206" x2="42.418" y2="48.641" width="0.254" layer="1"/>
+<wire x1="42.418" y1="48.641" x2="42.164" y2="48.895" width="0.254" layer="1"/>
+<wire x1="42.164" y1="48.895" x2="39.37" y2="48.895" width="0.254" layer="1"/>
 </signal>
 <signal name="MOTOR1_IN1/PHASE">
 <contactref element="U$6" pad="P10"/>
@@ -1851,13 +1890,25 @@ design rules under a new name.</description>
 <contactref element="U$8" pad="1"/>
 <contactref element="R3" pad="1"/>
 <contactref element="U$5" pad="P1"/>
-<wire x1="28.95" y1="36.83" x2="41.93" y2="46.294" width="0" layer="19" extent="1-1"/>
-<wire x1="16.7386" y1="40.0812" x2="28.95" y2="36.83" width="0" layer="19" extent="1-1"/>
+<wire x1="41.93" y1="46.294" x2="41.93" y2="44.47" width="0.4064" layer="1"/>
+<wire x1="41.93" y1="44.47" x2="41.91" y2="44.45" width="0.4064" layer="1"/>
+<wire x1="41.91" y1="44.45" x2="42.545" y2="43.815" width="0.4064" layer="1"/>
+<wire x1="42.545" y1="43.815" x2="43.053" y2="43.815" width="0.4064" layer="1"/>
+<wire x1="43.053" y1="43.815" x2="43.815" y2="43.053" width="0.4064" layer="1"/>
+<wire x1="43.815" y1="43.053" x2="43.815" y2="42.678" width="0.4064" layer="1"/>
+<wire x1="40.5638" y1="38.3286" x2="39.0144" y2="38.3286" width="0.4064" layer="1"/>
+<wire x1="39.0144" y1="38.3286" x2="38.608" y2="38.735" width="0.4064" layer="1"/>
+<wire x1="38.608" y1="38.735" x2="38.608" y2="41.402" width="0.4064" layer="1"/>
+<wire x1="38.608" y1="41.402" x2="39.116" y2="41.91" width="0.4064" layer="1"/>
+<wire x1="39.116" y1="41.91" x2="43.047" y2="41.91" width="0.4064" layer="1"/>
+<wire x1="43.047" y1="41.91" x2="43.815" y2="42.678" width="0.4064" layer="1"/>
 </signal>
 <signal name="N$5">
 <contactref element="U$8" pad="2"/>
 <contactref element="R3" pad="2"/>
-<wire x1="19.05" y1="40.0812" x2="34.55" y2="36.83" width="0" layer="19" extent="1-1"/>
+<wire x1="43.815" y1="37.078" x2="43.815" y2="39.116" width="0.4064" layer="1"/>
+<wire x1="43.815" y1="39.116" x2="42.291" y2="40.64" width="0.4064" layer="1"/>
+<wire x1="42.291" y1="40.64" x2="40.5638" y2="40.64" width="0.4064" layer="1"/>
 </signal>
 <signal name="MOTOR3+">
 <contactref element="U$5" pad="P2"/>